--[
renoise.tool():add_menu_entry {
  name = "Sample Editor:Process:selection+upbeat...",
  invoke = function() 
    test_main()
  end
 }
--]]

require ("selection_with_upbeat")

function test_main ()
local vb = renoise.ViewBuilder()
local get_x = 0
local get_x2 = 1
local get_unit = 1
local u = 1




local dialog_content = 
 vb:column
  {
    
    vb:space
    {
      height = 5
    },
        
-- upbeat with selection
   
    vb:row
    { 
        vb:textfield
        { 
          id = "selection_upbeat_val",
          tooltip = 
          "Input the number or the formula\n that represents the length of the upbeat part. \ne.g.\n  '0', '1/4', '(3/4)+(1/16)'",
          
          width = 160,
          text = "Upbeat (beat) ",
          notifier =
           function(x)       
             if pcall(loadstring('return '..x))==false
                or
                loadstring("return "..x)()==nil
                or
                loadstring("return "..x)()<0
              then
               renoise.app():show_error(
               [[Enter a number,
                or a numerical formula.
                e.g.
                '1.5' , '1/4' , '(3/4)+(1/16)']])
             else get_x=loadstring("return "..x)()
             end
            end
        },
        

         vb:button
        {
            width = 6,
            text = ("Get"),
            tooltip = 
            "Get the length of the selection range ,measured in beats.",
            notifier = 
              function()
                local val = round(selection2beat (),4)
                vb.views.selection_upbeat_val.text = tostring(val)
                get_x = tonumber(val)
              end,
         },
                    
    },
    
    vb:row
    {
        vb:button
        {
            width = 80,
            text = (" Replace "),
            tooltip =
            "Replace this sample with the selection range plus the upbeat part.",
            
            notifier = 
              function()
                replace_with_upbeat (beat_org(get_x))
              end,
         midi_mapping = "replace the sample :selection+upbeat"
         },
     
        vb:button
         {
            width = 80,
            text = " Add New ",
            tooltip =
            "Copy the selection range plus the upbeat part into new sample.",
                        
            notifier =
              function()
                set_new_with_upbeat (beat_org(get_x))
             end,
         midi_mapping = "add new sample :selection+upbeat"
        }
    },
        
        vb:space
        {
          height = 18
        },
        
        
-- set end

      vb:row
    { 
        vb:textfield
        { 
          id = "set_end_val",
          width = 160,
          text = "Selection range (beat) ",
          tooltip = 
          "Input the number or the formula that represents\n the selection range. \n e.g.\n  '4.5' , '1/4' , '16*3/4'.", 
                   
          notifier =
           function(x)       
             if pcall(loadstring('return '..x))==false
                or
                loadstring("return "..x)()==nil
                or
                loadstring("return "..x)()<=0
              then
               renoise.app():show_error(
               [[Enter a number greater than zero,
                or a numerical formula.
                e.g.
                '2.5' , '1/4' , '(32-18)/3'              
                  
                                ]])
             else get_x2=loadstring("return "..x)()
             end
            end
        },

 
         vb:button
        {
            width = 6,
            text = "Get",
            tooltip =
            "Get the length of the selection range ,measured in beats.",
            
            notifier = 
              function()
                local val = round(selection2beat (),4)
                vb.views.set_end_val.text = tostring(val)
                get_x2 = tonumber(val)
              end,
         },

      
     },
         
        
           
        vb:button
        {
           width = 80,
           text = " Set End ",
           tooltip =
           "Reset the selection end point.",
           
           notifier =
             function()
               set_end_point (beat_org(get_x2))
            end,
         midi_mapping = "set selection end point :selection+upbeat"
        },


-- sweep and sync_del

      vb:space
      {
        height = 18
      },
        
      vb:row
      {   
 
        vb:button
        { 
          width = 80,
          text = " Sweep ",
          tooltip =
          "Insert  the silence, \nits length is same as the selection range.",
          
          notifier =
            function ()  
              sweep_ins()
            end,
           midi_mapping =
           "sweep and insert silence :selection+upbeat"
        },

        
        vb:button
        {
            width = 80,
            text = " Delete ",
            tooltip =
            "Clear the selection range.",
            
            notifier = 
              function()
                sync_del()
              end,
            midi_mapping = 
              "delete the range and reset the sync value:selection+upbeat"              
         },

---[=[      
        vb:space
        {
          width = 10
        },      

        vb:button
        {
            width = 6,
            text = ("?"),
            notifier = 
              function()
               renoise.app():show_message(

" For sample offset etc.,set the selection range and input some value measured in beats. \n If the total length protrudes from the original sample,\n this tool automatically inserts  silence.\n According to the length, this tries to change the sync value.")

              end
        }
--]=]        
      },
      

      vb:space
      {
        height = 5
      },
  }

 renoise.app():show_custom_dialog("Selection + upbeat" , dialog_content)
end


